const path = require('path')
const fs = require('fs')

const updataRegister  = require('./updateRegister.js')
const { uppercamelcase, cameltoLowerCase }= require('../../src/utils/index')

process.on('exit', () => {
    console.log('>>>exit');
});

// console.log('>>>process.argv', process.argv)
/*
    '/Users/chengang/.nvm/versions/node/v12.18.2/bin/node',
    '/Users/chengang/web/vue test/vue-cli3/my-ui-project1/build/bin/addComponent.js',
    'test1',
    'NODE_ENV=dev'
*/

if (!process.argv[2]) {
    console.error('[组件名]必填 - Please enter new component name');
    process.exit(1);
}

const componentName = cameltoLowerCase(process.argv[2])
const exportName = uppercamelcase(componentName)
const chineseName = process.argv[3] || ''
const PackagePath = path.resolve(__dirname, '../../src/components')
console.log('componentName', componentName, exportName, chineseName)

const allComponentList = fs.readdirSync(PackagePath).filter(item => !(/(^|\/)\.[^\/\.]/g).test(item)) // 过滤隐藏目录

const componentPath = path.resolve(PackagePath, componentName)

console.log('>>>allComponentList', allComponentList)

if(~allComponentList.findIndex(item =>item == componentName)){
    console.log(`${componentName} 已存在.`);
    process.exit(1);
}else {
    fs.mkdirSync(componentPath)
}



const Files = [
    // js模板
    {
        fileName: 'index.js',
        content: `import ${exportName} from './index.vue'
${exportName}.install = function(Vue){
    Vue.component(${exportName}.name, ${componentName})
}
export default ${exportName}`
    },
    // .vue模板
    {
        fileName: 'index.vue',
        content: `<template>
    <div class="${componentName}-container"></div>
</template>
        
<script>
export default {
    name: '${componentName}',
    props: {

    },
    data() {
        return {}
    },
    methods: {

    }
}
</script>

<style lang="scss" scoped>
@import './index.scss';
</style>`
    },
    // demo模板
    {
        fileName: 'demo.vue',
        content: `<template>
</template>
      
<script>
    import ${exportName} from '../index'
    export default {
    components: {
        ${exportName}
    },
    props: {},
    data() {
        return {}
    },
    created() {},
    mounted() {},
    methods: {}
}
</script>`
    },
    // scss模板
    {
        fileName: 'index.scss',
        content: ``
    }

]

// 创建 组件文件
Files.forEach(file =>{
    const componentFilePath = path.resolve(componentPath, file.fileName)
    console.log('>>>componentFilePath', componentFilePath)
    fs.writeFileSync(componentFilePath, file.content)
})

allComponentList.push(componentName) 
updataRegister(allComponentList)



