var path = require('path')
var config = require('../config')
var utils = require('./utils')
var webpack = require('webpack')
var merge = require('webpack-merge')
var baseWebpackConfig = require('./webpack.base.conf')
var ExtractTextPlugin = require('extract-text-webpack-plugin')

var webpackConfig = merge(baseWebpackConfig, {
    entry: {
        tg: './src/registerFile.js'
    },
    module: {
        rules: [
            {
                test: /\.scss$/,
                loaders: ['style-loader', 'css-loader', 'sass-loader']
            }
        ]
    },
    devtool: config.build.productionSourceMap ? '#source-map' : false,
    output: {
        path: config.build.assetsRoot,
        filename: utils.assetsPath('index.js'),
        library: 'tg',
        libraryTarget: 'umd'
    },
    plugins: [
        // extract css into its own file
        // 注：extract-text-webpack-plugin还不能支持webpack4.0.0以上的版本。npm install –save-dev extract-text-webpack-plugin@next
        new ExtractTextPlugin(utils.assetsPath('style.css'))
    ],
    mode: 'production',
})


module.exports = webpackConfig